#include <stdio.h>
#include <winsock2.h>

#pragma comment(lib, "ws2_32.lib")

#define BUFFER_SIZE 256

int main()
{
	WSADATA wsadata;
	SOCKET srcSocket, dstSocket;
	struct sockaddr_in srcAddr, dstAddr;
	int len_srcAddr = sizeof(srcAddr);
	int len_dstAddr = sizeof(dstAddr);
	int ret;
	
	//hoAhXƃ|[gԍ̎w
	memset(&srcAddr, '0', len_srcAddr);
	srcAddr.sin_family = AF_INET;
	srcAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	srcAddr.sin_port = htons(10260);//OȂnrŎ蓖
	
	//Winsock
	ret = WSAStartup(MAKEWORD(2,0), &wsadata);
	if (ret != 0) {
		printf("SYSTEM: %d WSAStartup Error!\n", WSAGetLastError());
		return 1;
	}
	printf("SYSTEM: WSAStartup successful.\n");
	
	//Socket̐
	srcSocket = socket(AF_INET, SOCK_STREAM, 0);
	if (srcSocket == INVALID_SOCKET) {
		printf("SYSTEM: %d socket Error!\n", WSAGetLastError());
		return 1;
	}
	printf("SYSTEM: socket successful.\n");
	
	//Socketsockaddr_in\̂̊֘At
	ret = bind(srcSocket, (struct sockaddr *)&srcAddr, len_srcAddr);
	if (ret == SOCKET_ERROR) {
		printf("SYSTEM: %d bind Error!\n", WSAGetLastError());
		return 1;
	}
	printf("SYSTEM: bind successful.\n");
	
	//ڑ
	ret = listen(srcSocket, 5);
	if (ret == SOCKET_ERROR) {
		printf("SYSTEM: %d listen Error!\n", WSAGetLastError());
		return 1;
	}
	printf("SYSTEM: listen successful.\n");
	
	//ڑҋ@
	dstSocket = accept(srcSocket, (struct sockaddr *)&dstAddr, &len_dstAddr);
	if (dstSocket == INVALID_SOCKET) {
		printf("SYSTEM: %d accept Error!\n", WSAGetLastError());
		return 1;
	}
	printf("SYSTEM: accept successful.\n");
	printf("Connected from %s.\n", inet_ntoa(dstAddr.sin_addr));
	
	//f[^M
	char recv_data[BUFFER_SIZE];
	recv(dstSocket, recv_data, BUFFER_SIZE, 0);
	
	//f[^\
	printf("MESSAGE: %s\n", recv_data);
	
	//Socket
	ret = closesocket(dstSocket);
	if (ret == SOCKET_ERROR) {
		printf("SYSTEM: %d dst closesocket Error!\n", WSAGetLastError());
		closesocket(srcSocket);
		return 1;
	}
	ret = closesocket(srcSocket);
	if (ret == SOCKET_ERROR) {
		printf("SYSTEM: %d src closesocket Error!\n", WSAGetLastError());
		return 1;
	}
	printf("SYSTEM: closesocket successful.\n");
	
	//Winsock㏈
	ret = WSACleanup();
	if (ret == SOCKET_ERROR) {
		printf("SYSTEM: %d WSACleanup Error!\n", WSAGetLastError());
		return 1;
	}
	printf("SYSTEM: WSACleanup successful.\n");
	
	return 0;
}
