#include <stdio.h>
#include <string.h>
#include <winsock2.h>

#pragma comment(lib, "ws2_32.lib")

#define BUFFER_SIZE 256

int main()
{
	WSADATA wsadata;
	struct hostent sHost;
	int ret;
	
	//Winsock
	ret = WSAStartup(MAKEWORD(2,0), &wsadata);
	if (ret != 0) {
		printf("SYSTEM: %d WSAStartup Error!\n", WSAGetLastError());
		return 1;
	}
	printf("SYSTEM: WSAStartup successful.\n");
	
	//zXg擾
	char sHostname[BUFFER_SIZE];
	ret = gethostname(sHostname, BUFFER_SIZE);
	if (ret == SOCKET_ERROR) {
		printf("SYSTEM: %d gethostname Error!\n", WSAGetLastError());
		return 1;
	}
	printf("SYSTEM: %s\n", sHostname);
	
	//zXghoɕϊ
	sHost = *gethostbyname(sHostname);
	printf("SYSTEM: %s - %d.%d.%d.%d\n",
		sHost.h_name, sHost.h_addr_list[0][0] & 0xff, sHost.h_addr_list[0][1] & 0xff,
		sHost.h_addr_list[0][2] & 0xff, sHost.h_addr_list[0][3] & 0xff);
	
	//Winsock㏈
	ret = WSACleanup();
	if (ret == SOCKET_ERROR) {
		printf("SYSTEM: %d WSACleanup Error!\n", WSAGetLastError());
		return 1;
	}
	printf("SYSTEM: WSACleanup successful.\n");
	
	return 0;
}
